import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;
import vt.cs.widgets.*;

class RLCanvas extends Canvas {
    RLImage rli;
    Image img = null;
    RLImageNames names;
    int xOffset = 0;
    int yOffset = 0;

    RLCanvas(RLImage rli, RLImageNames names) {
        this.rli = rli;
        this.names = names;

        img = createImage(rli);
        resize(rli.width + xOffset, rli.height + yOffset);
    }

    public void paint(Graphics g) {
        try {
            if (img == null)
                img = getToolkit().
                    getImage(new URL("http://csgrad.cs.vt.edu/~jnielsen/images/fampict.jpeg"));
            g.drawImage(img, xOffset, yOffset, this);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Overrides Component.update so that it doesn't clear the
     * background before calling paint().  Makes for 
     * less flickering.
     */ 
    public void update(Graphics g) { paint(g); }

    public boolean mouseMove(Event evt, int x, int y) {
        x -= xOffset;
        y -= yOffset;
        System.out.print(""+ x + "," + y +
                ": ");
        try {
            System.out.print(names.getName(rli.getPixel(x,y)));
        } catch (Exception e) {
        }
        System.out.println();

        return true;
    }

}
       
public class RLScroll extends Frame {
    RadarPane scroll;
    RLImage rli;

    RLScroll(String imagefile, String namefile) {
        super("RLImage Example");
        try {
            rli = new RLImage(new BufferedInputStream(new FileInputStream(imagefile)), true);
            System.out.println(rli.toString());

            scroll = new RadarPane();
            scroll.add(new RLCanvas(rli, 
                new RLImageNames(new BufferedInputStream(
                new FileInputStream(namefile)))));
//            scroll.resize(rli.width + scroll.getVScrollbarWidth(), 
//                rli.height + scroll.getHScrollbarHeight());
            scroll.setSize(400, 250);
            add(scroll);
            pack();

            show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    public static void main(String[] args) {
        if (args.length < 2) {
            System.out.println("USAGE: Java RLScroll <imagefile> <namefile>");
            return;
        }
        new RLScroll(args[0], args[1]);
    }

    public boolean handleEvent(Event evt) {
        if (evt.id == Event.WINDOW_DESTROY) {
                dispose();
                System.exit(0);
                return true;
            }
        else return super.handleEvent(evt);
    }


}


