import java.awt.*;
import java.awt.image.*;


class SimplerColorModel extends ColorModel {
    private int transIndex = -1;

    SimplerColorModel() { super(3); }
    SimplerColorModel(int trans) { 
        super(3); 
        transIndex = trans;
    }


    public int getAlpha(int  pixel) { 
        if (pixel == transIndex) return 0;
        else return 255;
    }
    public int getBlue(int  pixel) {
        return map(pixel).getBlue();
    }
    public int getGreen(int  pixel) {
        return map(pixel).getGreen();
    }
    public int getRed(int  pixel) {
        return map(pixel).getRed();
    }
    
    
    private Color map(int val) { 
        switch (val % 8) {
          case 5: return Color.black;
          case 4: return Color.red;
          case 7: return Color.blue;
          case 6: return Color.green;
          case 2: return Color.orange;
          case 1: return Color.pink;
          case 3: return Color.white;
          case 0: return Color.yellow;
        }

        return Color.black;
    }
}


