import java.awt.*;
import java.awt.image.*;

class SingleColorModel extends ColorModel {
    private int offset;
    private int color;

    SingleColorModel(int offset, int color) {
        super(32);
        this.offset = offset;
        this.color = color;
    }


    public int getAlpha(int  pixel) {
        if (pixel >= offset) return color & 0xff000000;	// fully opaque
        else return 0;
    }
    
    /**
     * Returns the red color compoment for the specified pixel in the
     * range 0-255.
     */
    final public int getRed(int pixel) {
        if (pixel >= offset) return color & 0xff0000;
        else return 0;
    }

    /**
     * Returns the green color compoment for the specified pixel in the
     * range 0-255.
     */
    final public int getGreen(int pixel) {
        if (pixel >= offset) return color & 0xff00;
        else return 0;
    }

    /**
     * Returns the blue color compoment for the specified pixel in the
     * range 0-255.
     */
    final public int getBlue(int pixel) {
        if (pixel >= offset) return color & 0xff;
        else return 0;
    }

    public int getRGB(int pixel) {
        if (pixel >= offset) return color;
        else return 0;
    }

}





